import HighlightJS from "../node_modules/.pnpm/highlight.js@11.10.0/node_modules/highlight.js/lib/index.mjs";
function escapeHtml(value) {
  return value.replace(/&/g, "&amp;").replace(/</g, "&lt;").replace(/>/g, "&gt;").replace(/"/g, "&quot;").replace(/'/g, "&#x27;");
}
const highlightTohtml = (code, options) => {
  const { language, ignoreIllegals, autoMatch } = options;
  const autodetect = autoMatch || !language;
  if (!HighlightJS.getLanguage(language)) {
    console.warn(
      `The language "${language}" you specified could not be found.`
    );
    return escapeHtml(code);
  }
  if (autodetect) {
    const result = HighlightJS.highlightAuto(code);
    return result.value;
  } else {
    const result = HighlightJS.highlight(code, {
      language,
      ignoreIllegals
    });
    return result.value;
  }
};
const hljsGetLanguage = (language) => {
  return HighlightJS.getLanguage(language);
};
export {
  escapeHtml,
  highlightTohtml,
  hljsGetLanguage
};
