import { Markdown as MarkdownRender, MarkdownOptions } from './markdown';
export * from './utils';
export { MarkdownRender };
export type { MarkdownOptions } from './markdown';
export * from '../micromark-extension-tag';
export declare type ExtraProps = {
    openRehypeRaw: boolean;
};
export declare type MarkdownProps = Omit<MarkdownOptions, 'children'> & ExtraProps;
export declare const Markdownprops: {
    source: {
        type: StringConstructor;
        required: boolean;
    };
    allowElement: {
        type: PropType<(node: any, index: number, parent: any) => boolean>;
        required: boolean;
    };
    components: {
        type: PropType<Record<string, any>>;
        required: boolean;
    };
    customElements: {
        type: PropType<string[]>;
        required: boolean;
    };
    allowedElements: {
        type: PropType<string[]>;
        required: boolean;
    };
    disallowedElements: {
        type: PropType<string[]>;
        required: boolean;
    };
    rehypePlugins: {
        type: PropType<any[]>;
        required: boolean;
    };
    remarkPlugins: {
        type: PropType<any[]>;
        required: boolean;
    };
    /**需要具体化选项的类型*/
    remarkRehypeOptions: {
        type: PropType<object>;
        required: boolean;
    };
    skipHtml: {
        type: PropType<boolean>;
        required: boolean;
    };
    unwrapDisallowed: {
        type: PropType<boolean>;
        required: boolean;
    };
    urlTransform: {
        type: PropType<(url: string, attribute: string, node: any) => string>;
        required: boolean;
    };
};
export declare const Markdown: any;
