import { blockquote } from "./blockquote.mjs";
import { hardBreak } from "./break.mjs";
import { code } from "./code.mjs";
import { strikethrough } from "./delete.mjs";
import { emphasis } from "./emphasis.mjs";
import { footnoteReference } from "./footnote-reference.mjs";
import { heading } from "./heading.mjs";
import { html } from "./html.mjs";
import { imageReference } from "./image-reference.mjs";
import { image } from "./image.mjs";
import { inlineCode } from "./inline-code.mjs";
import { linkReference } from "./link-reference.mjs";
import { link } from "./link.mjs";
import { listItem } from "./list-item.mjs";
import { list } from "./list.mjs";
import { paragraph } from "./paragraph.mjs";
import { root } from "./root.mjs";
import { strong } from "./strong.mjs";
import { table } from "./table.mjs";
import { tableRow } from "./table-row.mjs";
import { tableCell } from "./table-cell.mjs";
import { text } from "./text.mjs";
import { thematicBreak } from "./thematic-break.mjs";
const handlers = {
  blockquote,
  break: hardBreak,
  code,
  delete: strikethrough,
  emphasis,
  footnoteReference,
  heading,
  html,
  imageReference,
  image,
  inlineCode,
  linkReference,
  link,
  listItem,
  list,
  paragraph,
  // @ts-expect-error: root is different, but hard to type.
  root,
  strong,
  table,
  tableCell,
  tableRow,
  text,
  thematicBreak,
  toml: ignore,
  yaml: ignore,
  definition: ignore,
  footnoteDefinition: ignore
};
function ignore() {
  return void 0;
}
export {
  handlers
};
