import { resolver } from "./initialize/text.mjs";
import { list } from "../../../../micromark-core-commonmark@2.0.1/node_modules/micromark-core-commonmark/lib/list.mjs";
import { blockQuote } from "../../../../micromark-core-commonmark@2.0.1/node_modules/micromark-core-commonmark/lib/block-quote.mjs";
import { definition } from "../../../../micromark-core-commonmark@2.0.1/node_modules/micromark-core-commonmark/lib/definition.mjs";
import { codeIndented } from "../../../../micromark-core-commonmark@2.0.1/node_modules/micromark-core-commonmark/lib/code-indented.mjs";
import { headingAtx } from "../../../../micromark-core-commonmark@2.0.1/node_modules/micromark-core-commonmark/lib/heading-atx.mjs";
import { thematicBreak } from "../../../../micromark-core-commonmark@2.0.1/node_modules/micromark-core-commonmark/lib/thematic-break.mjs";
import { setextUnderline } from "../../../../micromark-core-commonmark@2.0.1/node_modules/micromark-core-commonmark/lib/setext-underline.mjs";
import { htmlFlow } from "../../../../micromark-core-commonmark@2.0.1/node_modules/micromark-core-commonmark/lib/html-flow.mjs";
import { codeFenced } from "../../../../micromark-core-commonmark@2.0.1/node_modules/micromark-core-commonmark/lib/code-fenced.mjs";
import { characterReference } from "../../../../micromark-core-commonmark@2.0.1/node_modules/micromark-core-commonmark/lib/character-reference.mjs";
import { characterEscape } from "../../../../micromark-core-commonmark@2.0.1/node_modules/micromark-core-commonmark/lib/character-escape.mjs";
import { lineEnding } from "../../../../micromark-core-commonmark@2.0.1/node_modules/micromark-core-commonmark/lib/line-ending.mjs";
import { labelStartImage } from "../../../../micromark-core-commonmark@2.0.1/node_modules/micromark-core-commonmark/lib/label-start-image.mjs";
import { attention } from "../../../../micromark-core-commonmark@2.0.1/node_modules/micromark-core-commonmark/lib/attention.mjs";
import { autolink } from "../../../../micromark-core-commonmark@2.0.1/node_modules/micromark-core-commonmark/lib/autolink.mjs";
import { htmlText } from "../../../../micromark-core-commonmark@2.0.1/node_modules/micromark-core-commonmark/lib/html-text.mjs";
import { labelStartLink } from "../../../../micromark-core-commonmark@2.0.1/node_modules/micromark-core-commonmark/lib/label-start-link.mjs";
import { hardBreakEscape } from "../../../../micromark-core-commonmark@2.0.1/node_modules/micromark-core-commonmark/lib/hard-break-escape.mjs";
import { labelEnd } from "../../../../micromark-core-commonmark@2.0.1/node_modules/micromark-core-commonmark/lib/label-end.mjs";
import { codeText } from "../../../../micromark-core-commonmark@2.0.1/node_modules/micromark-core-commonmark/lib/code-text.mjs";
const document = {
  [42]: list,
  [43]: list,
  [45]: list,
  [48]: list,
  [49]: list,
  [50]: list,
  [51]: list,
  [52]: list,
  [53]: list,
  [54]: list,
  [55]: list,
  [56]: list,
  [57]: list,
  [62]: blockQuote
};
const contentInitial = {
  [91]: definition
};
const flowInitial = {
  [-2]: codeIndented,
  [-1]: codeIndented,
  [32]: codeIndented
};
const flow = {
  [35]: headingAtx,
  [42]: thematicBreak,
  [45]: [setextUnderline, thematicBreak],
  [60]: htmlFlow,
  [61]: setextUnderline,
  [95]: thematicBreak,
  [96]: codeFenced,
  [126]: codeFenced
};
const string = {
  [38]: characterReference,
  [92]: characterEscape
};
const text = {
  [-5]: lineEnding,
  [-4]: lineEnding,
  [-3]: lineEnding,
  [33]: labelStartImage,
  [38]: characterReference,
  [42]: attention,
  [60]: [autolink, htmlText],
  [91]: labelStartLink,
  [92]: [hardBreakEscape, characterEscape],
  [93]: labelEnd,
  [95]: attention,
  [96]: codeText
};
const insideSpan = {
  null: [attention, resolver]
};
const attentionMarkers = {
  null: [42, 95]
};
const disable = {
  null: []
};
export {
  attentionMarkers,
  contentInitial,
  disable,
  document,
  flow,
  flowInitial,
  insideSpan,
  string,
  text
};
