import { Prism } from "./prism-core.mjs";
import { h } from "../../../../hastscript@7.2.0/node_modules/hastscript/lib/html.mjs";
import { parseEntities } from "../../../../parse-entities@4.0.1/node_modules/parse-entities/lib/index.mjs";
const own = {}.hasOwnProperty;
function Refractor() {
}
Refractor.prototype = Prism;
const refractor = new Refractor();
refractor.highlight = highlight;
refractor.register = register;
refractor.alias = alias;
refractor.registered = registered;
refractor.listLanguages = listLanguages;
refractor.util.encode = encode;
refractor.Token.stringify = stringify;
function highlight(value, language) {
  if (typeof value !== "string") {
    throw new TypeError("Expected `string` for `value`, got `" + value + "`");
  }
  let grammar;
  let name;
  if (language && typeof language === "object") {
    grammar = language;
  } else {
    name = language;
    if (typeof name !== "string") {
      throw new TypeError("Expected `string` for `name`, got `" + name + "`");
    }
    if (own.call(refractor.languages, name)) {
      grammar = refractor.languages[name];
    } else {
      throw new Error("Unknown language: `" + name + "` is not registered");
    }
  }
  return {
    type: "root",
    // @ts-expect-error: we hacked Prism to accept and return the things we want.
    children: Prism.highlight.call(refractor, value, grammar, name)
  };
}
function register(syntax) {
  if (typeof syntax !== "function" || !syntax.displayName) {
    throw new Error("Expected `function` for `syntax`, got `" + syntax + "`");
  }
  if (!own.call(refractor.languages, syntax.displayName)) {
    syntax(refractor);
  }
}
function alias(language, alias2) {
  const languages = refractor.languages;
  let map = {};
  if (typeof language === "string") {
    if (alias2) {
      map[language] = alias2;
    }
  } else {
    map = language;
  }
  let key;
  for (key in map) {
    if (own.call(map, key)) {
      const value = map[key];
      const list = typeof value === "string" ? [value] : value;
      let index = -1;
      while (++index < list.length) {
        languages[list[index]] = languages[key];
      }
    }
  }
}
function registered(aliasOrLanguage) {
  if (typeof aliasOrLanguage !== "string") {
    throw new TypeError(
      "Expected `string` for `aliasOrLanguage`, got `" + aliasOrLanguage + "`"
    );
  }
  return own.call(refractor.languages, aliasOrLanguage);
}
function listLanguages() {
  const languages = refractor.languages;
  const list = [];
  let language;
  for (language in languages) {
    if (own.call(languages, language) && typeof languages[language] === "object") {
      list.push(language);
    }
  }
  return list;
}
function stringify(value, language) {
  if (typeof value === "string") {
    return { type: "text", value };
  }
  if (Array.isArray(value)) {
    const result = [];
    let index = -1;
    while (++index < value.length) {
      if (value[index] !== "" && value[index] !== null && value[index] !== void 0) {
        result.push(stringify(value[index], language));
      }
    }
    return result;
  }
  const env = {
    type: value.type,
    content: stringify(value.content, language),
    tag: "span",
    classes: ["token", value.type],
    attributes: {},
    language
  };
  if (value.alias) {
    env.classes.push(
      ...typeof value.alias === "string" ? [value.alias] : value.alias
    );
  }
  refractor.hooks.run("wrap", env);
  return h(
    env.tag + "." + env.classes.join("."),
    attributes(env.attributes),
    env.content
  );
}
function encode(tokens) {
  return tokens;
}
function attributes(attrs) {
  let key;
  for (key in attrs) {
    if (own.call(attrs, key)) {
      attrs[key] = parseEntities(attrs[key]);
    }
  }
  return attrs;
}
export {
  refractor
};
