"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const index = require("../node_modules/.pnpm/highlight.js@11.10.0/node_modules/highlight.js/lib/index.js");
function escapeHtml(value) {
  return value.replace(/&/g, "&amp;").replace(/</g, "&lt;").replace(/>/g, "&gt;").replace(/"/g, "&quot;").replace(/'/g, "&#x27;");
}
const highlightTohtml = (code, options) => {
  const { language, ignoreIllegals, autoMatch } = options;
  const autodetect = autoMatch || !language;
  if (!index.default.getLanguage(language)) {
    console.warn(
      `The language "${language}" you specified could not be found.`
    );
    return escapeHtml(code);
  }
  if (autodetect) {
    const result = index.default.highlightAuto(code);
    return result.value;
  } else {
    const result = index.default.highlight(code, {
      language,
      ignoreIllegals
    });
    return result.value;
  }
};
const hljsGetLanguage = (language) => {
  return index.default.getLanguage(language);
};
exports.escapeHtml = escapeHtml;
exports.highlightTohtml = highlightTohtml;
exports.hljsGetLanguage = hljsGetLanguage;
