"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const vueJsxRuntime_esmBrowser = require("../node_modules/.pnpm/vue-jsx-runtime@0.1.0_vue@3.4.35_typescript@5.5.4_/node_modules/vue-jsx-runtime/dist/vue-jsx-runtime.esm-browser.js");
const utils = require("./utils.js");
const merge = require("../node_modules/.pnpm/lodash@4.17.21/node_modules/lodash/merge.js");
const index = require("../node_modules/.pnpm/unified@11.0.5/node_modules/unified/lib/index.js");
const index$1 = require("../node_modules/.pnpm/remark-parse@11.0.0/node_modules/remark-parse/lib/index.js");
const index$2 = require("../node_modules/.pnpm/remark-rehype@11.1.0/node_modules/remark-rehype/lib/index.js");
const index$3 = require("../node_modules/.pnpm/vfile@6.0.2/node_modules/vfile/lib/index.js");
const index$4 = require("../node_modules/.pnpm/unist-util-visit@5.0.0/node_modules/unist-util-visit/lib/index.js");
const index$5 = require("../node_modules/.pnpm/hast-util-to-jsx-runtime@2.3.0/node_modules/hast-util-to-jsx-runtime/lib/index.js");
const index$6 = require("../node_modules/.pnpm/html-url-attributes@3.0.0/node_modules/html-url-attributes/lib/index.js");
const vue = require("vue");
const emptyPlugins = [];
const emptyRemarkRehypeOptions = {
  allowDangerousHtml: true
};
const safeProtocol = /^(https?|ircs?|mailto|xmpp)$/i;
const matchTag = (tags, value) => {
  if (!Array.isArray(tags)) {
    return false;
  }
  return tags.some(
    (tag) => utils.getStartTag(value, tag) === 0 || utils.getEndTag(value, tag) === 0
  );
};
const markdown_token_raw = "markdown_token_raw";
const getDefaultHandlers = (tags) => {
  return {
    html: (state, node, parent) => {
      if (node.value && matchTag(tags, node.value)) {
        const result = { type: "raw", value: node.value };
        state.patch(node, result);
        return state.applyData(node, result);
      }
      if (state.options.allowDangerousHtml) {
        const result = { type: markdown_token_raw, value: node.value };
        state.patch(node, result);
        return state.applyData(node, result);
      }
    }
  };
};
function Markdown(options) {
  const allowedElements = options.allowedElements;
  const allowElement = options.allowElement;
  const children = options.children || "";
  const className = options.className;
  const components = options.components;
  const disallowedElements = options.disallowedElements;
  const rehypePlugins = options.rehypePlugins || emptyPlugins;
  const remarkPlugins = options.remarkPlugins || emptyPlugins;
  let handlers = {};
  if (Array.isArray(options.customElements) && options.customElements.length > 0) {
    handlers = getDefaultHandlers(options.customElements);
  }
  const _remarkRehypeOptions = merge.default({ handlers }, options.remarkRehypeOptions);
  const remarkRehypeOptions = options.remarkRehypeOptions ? { ..._remarkRehypeOptions, ...emptyRemarkRehypeOptions } : { ...emptyRemarkRehypeOptions, handlers };
  const skipHtml = options.skipHtml;
  const unwrapDisallowed = options.unwrapDisallowed;
  const urlTransform = options.urlTransform || defaultUrlTransform;
  const processor = index.unified().use(index$1.default).use(remarkPlugins).use(index$2.default, remarkRehypeOptions).use(rehypePlugins);
  const file = new index$3.VFile();
  if (typeof children === "string") {
    file.value = children;
  }
  const mdastTree = processor.parse(file);
  let hastTree = processor.runSync(mdastTree, file);
  if (className) {
    hastTree = {
      type: "element",
      tagName: "div",
      properties: { className },
      children: hastTree.type === "root" ? hastTree.children : [hastTree]
    };
  }
  index$4.visit(hastTree, transform);
  const tree = index$5.toJsxRuntime(hastTree, {
    Fragment: vue.Fragment,
    components,
    ignoreInvalidStyle: true,
    jsx: vueJsxRuntime_esmBrowser.jsx,
    jsxs: vueJsxRuntime_esmBrowser.jsxs,
    passKeys: true,
    passNode: true,
    elementAttributeNameCase: "html"
  });
  return tree;
  function transform(node, index2, parent) {
    if (node.type === "raw" && parent && typeof index2 === "number") {
      if (skipHtml) {
        parent.children.splice(index2, 1);
      } else {
        parent.children[index2] = { type: "text", value: node.value };
      }
      return index2;
    }
    if (node.type === markdown_token_raw && parent && typeof index2 === "number") {
      console.log("markdown_token_raw——transform", node, index2, parent);
      if (skipHtml) {
        parent.children.splice(index2, 1);
      } else {
        parent.children[index2] = { type: "text", value: node.value };
      }
      return index2;
    }
    if (node.type === "element") {
      let key;
      for (key in index$6.urlAttributes) {
        if (index$6.urlAttributes.hasOwnProperty(key) && node.properties.hasOwnProperty(key)) {
          const value = node.properties[key];
          const test = index$6.urlAttributes[key];
          if (test === null || test.includes(node.tagName)) {
            node.properties[key] = urlTransform(String(value || ""), key, node);
          }
        }
      }
    }
    if (node.type === "element") {
      let remove = allowedElements ? !allowedElements.includes(node.tagName) : disallowedElements ? disallowedElements.includes(node.tagName) : false;
      if (!remove && allowElement && typeof index2 === "number") {
        remove = !allowElement(node, index2, parent);
      }
      if (remove && parent && typeof index2 === "number") {
        if (unwrapDisallowed && node.children) {
          parent.children.splice(index2, 1, ...node.children);
        } else {
          parent.children.splice(index2, 1);
        }
        return index2;
      }
    }
  }
}
function defaultUrlTransform(value) {
  const colon = value.indexOf(":");
  const questionMark = value.indexOf("?");
  const numberSign = value.indexOf("#");
  const slash = value.indexOf("/");
  if (
    // If there is no protocol, it’s relative.
    colon < 0 || // If the first colon is after a `?`, `#`, or `/`, it’s not a protocol.
    slash > -1 && colon > slash || questionMark > -1 && colon > questionMark || numberSign > -1 && colon > numberSign || // It is a protocol, it should be allowed.
    safeProtocol.test(value.slice(0, colon))
  ) {
    return value;
  }
  return "";
}
exports.Markdown = Markdown;
exports.defaultUrlTransform = defaultUrlTransform;
exports.getDefaultHandlers = getDefaultHandlers;
exports.markdown_token_raw = markdown_token_raw;
