"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
function think() {
  return {
    // 定义一个新的 token 类型
    text: {
      tokenize: tokenizeThink,
      locate: locateThink
    }
  };
}
function locateThink(effects, ok, nok) {
  return (start) => {
    const self = this;
    const slice = self.sliceSubstring(start);
    const openTag = slice.startsWith("<think>");
    const closeTag = slice.startsWith("</think>");
    if (openTag) {
      effects.enter("thinkOpen");
      effects.consume(start + 6);
      effects.exit("thinkOpen");
      return ok(start + 6);
    } else if (closeTag) {
      effects.enter("thinkClose");
      effects.consume(start + 7);
      effects.exit("thinkClose");
      return ok(start + 7);
    }
    return nok(start);
  };
}
function tokenizeThink(effects, ok, nok) {
  const self = this;
  const slice = self.sliceSubstring(self.now().column);
  const openTag = slice.startsWith("<think>");
  const closeTag = slice.startsWith("</think>");
  if (openTag) {
    effects.enter("thinkOpen");
    effects.consume(6);
    effects.exit("thinkOpen");
    return ok();
  } else if (closeTag) {
    effects.enter("thinkClose");
    effects.consume(7);
    effects.exit("thinkClose");
    return ok();
  }
  return nok();
}
function rehypeCustomThinkTag(options) {
  options.tags || [];
  const data = this.data();
  console.log(data);
  return (tree) => {
    console.log("rehypeCustomThinkTag_tree", tree);
  };
}
exports.rehypeCustomThinkTag = rehypeCustomThinkTag;
exports.think = think;
