"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const siblings = require("./util/siblings.js");
const closing = require("./closing.js");
const omission = require("./omission.js");
const index = require("../../../../../hast-util-whitespace@3.0.0/node_modules/hast-util-whitespace/lib/index.js");
const opening = omission.omission({
  body,
  colgroup,
  head,
  html,
  tbody
});
function html(node) {
  const head2 = siblings.siblingAfter(node, -1);
  return !head2 || head2.type !== "comment";
}
function head(node) {
  const children = node.children;
  const seen = [];
  let index2 = -1;
  while (++index2 < children.length) {
    const child = children[index2];
    if (child.type === "element" && (child.tagName === "title" || child.tagName === "base")) {
      if (seen.includes(child.tagName)) return false;
      seen.push(child.tagName);
    }
  }
  return children.length > 0;
}
function body(node) {
  const head2 = siblings.siblingAfter(node, -1, true);
  return !head2 || head2.type !== "comment" && !(head2.type === "text" && index.whitespace(head2.value.charAt(0))) && !(head2.type === "element" && (head2.tagName === "meta" || head2.tagName === "link" || head2.tagName === "script" || head2.tagName === "style" || head2.tagName === "template"));
}
function colgroup(node, index2, parent) {
  const previous = siblings.siblingBefore(parent, index2);
  const head2 = siblings.siblingAfter(node, -1, true);
  if (parent && previous && previous.type === "element" && previous.tagName === "colgroup" && closing.closing(previous, parent.children.indexOf(previous), parent)) {
    return false;
  }
  return Boolean(head2 && head2.type === "element" && head2.tagName === "col");
}
function tbody(node, index2, parent) {
  const previous = siblings.siblingBefore(parent, index2);
  const head2 = siblings.siblingAfter(node, -1);
  if (parent && previous && previous.type === "element" && (previous.tagName === "thead" || previous.tagName === "tbody") && closing.closing(previous, parent.children.indexOf(previous), parent)) {
    return false;
  }
  return Boolean(head2 && head2.type === "element" && head2.tagName === "tr");
}
exports.opening = opening;
