"use strict";
Object.defineProperties(exports, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
const _commonjsHelpers = require("../../../../../../_virtual/_commonjsHelpers.js");
const core = require("./core.js");
const _1c = require("./languages/1c.js");
const abnf = require("./languages/abnf.js");
const accesslog = require("./languages/accesslog.js");
const actionscript = require("./languages/actionscript.js");
const ada = require("./languages/ada.js");
const angelscript = require("./languages/angelscript.js");
const apache = require("./languages/apache.js");
const applescript = require("./languages/applescript.js");
const arcade = require("./languages/arcade.js");
const arduino = require("./languages/arduino.js");
const armasm = require("./languages/armasm.js");
const xml = require("./languages/xml.js");
const asciidoc = require("./languages/asciidoc.js");
const aspectj = require("./languages/aspectj.js");
const autohotkey = require("./languages/autohotkey.js");
const autoit = require("./languages/autoit.js");
const avrasm = require("./languages/avrasm.js");
const awk = require("./languages/awk.js");
const axapta = require("./languages/axapta.js");
const bash = require("./languages/bash.js");
const basic = require("./languages/basic.js");
const bnf = require("./languages/bnf.js");
const brainfuck = require("./languages/brainfuck.js");
const c = require("./languages/c.js");
const cal = require("./languages/cal.js");
const capnproto = require("./languages/capnproto.js");
const ceylon = require("./languages/ceylon.js");
const clean = require("./languages/clean.js");
const clojure = require("./languages/clojure.js");
const clojureRepl = require("./languages/clojure-repl.js");
const cmake = require("./languages/cmake.js");
const coffeescript = require("./languages/coffeescript.js");
const coq = require("./languages/coq.js");
const cos = require("./languages/cos.js");
const cpp = require("./languages/cpp.js");
const crmsh = require("./languages/crmsh.js");
const crystal = require("./languages/crystal.js");
const csharp = require("./languages/csharp.js");
const csp = require("./languages/csp.js");
const css = require("./languages/css.js");
const d = require("./languages/d.js");
const markdown = require("./languages/markdown.js");
const dart = require("./languages/dart.js");
const delphi = require("./languages/delphi.js");
const diff = require("./languages/diff.js");
const django = require("./languages/django.js");
const dns = require("./languages/dns.js");
const dockerfile = require("./languages/dockerfile.js");
const dos = require("./languages/dos.js");
const dsconfig = require("./languages/dsconfig.js");
const dts = require("./languages/dts.js");
const dust = require("./languages/dust.js");
const ebnf = require("./languages/ebnf.js");
const elixir = require("./languages/elixir.js");
const elm = require("./languages/elm.js");
const ruby = require("./languages/ruby.js");
const erb = require("./languages/erb.js");
const erlangRepl = require("./languages/erlang-repl.js");
const erlang = require("./languages/erlang.js");
const excel = require("./languages/excel.js");
const fix = require("./languages/fix.js");
const flix = require("./languages/flix.js");
const fortran = require("./languages/fortran.js");
const fsharp = require("./languages/fsharp.js");
const gams = require("./languages/gams.js");
const gauss = require("./languages/gauss.js");
const gcode = require("./languages/gcode.js");
const gherkin = require("./languages/gherkin.js");
const glsl = require("./languages/glsl.js");
const gml = require("./languages/gml.js");
const go = require("./languages/go.js");
const golo = require("./languages/golo.js");
const gradle = require("./languages/gradle.js");
const graphql = require("./languages/graphql.js");
const groovy = require("./languages/groovy.js");
const haml = require("./languages/haml.js");
const handlebars = require("./languages/handlebars.js");
const haskell = require("./languages/haskell.js");
const haxe = require("./languages/haxe.js");
const hsp = require("./languages/hsp.js");
const http = require("./languages/http.js");
const hy = require("./languages/hy.js");
const inform7 = require("./languages/inform7.js");
const ini = require("./languages/ini.js");
const irpf90 = require("./languages/irpf90.js");
const isbl = require("./languages/isbl.js");
const java = require("./languages/java.js");
const javascript = require("./languages/javascript.js");
const jbossCli = require("./languages/jboss-cli.js");
const json = require("./languages/json.js");
const julia = require("./languages/julia.js");
const juliaRepl = require("./languages/julia-repl.js");
const kotlin = require("./languages/kotlin.js");
const lasso = require("./languages/lasso.js");
const latex = require("./languages/latex.js");
const ldif = require("./languages/ldif.js");
const leaf = require("./languages/leaf.js");
const less = require("./languages/less.js");
const lisp = require("./languages/lisp.js");
const livecodeserver = require("./languages/livecodeserver.js");
const livescript = require("./languages/livescript.js");
const llvm = require("./languages/llvm.js");
const lsl = require("./languages/lsl.js");
const lua = require("./languages/lua.js");
const makefile = require("./languages/makefile.js");
const mathematica = require("./languages/mathematica.js");
const matlab = require("./languages/matlab.js");
const maxima = require("./languages/maxima.js");
const mel = require("./languages/mel.js");
const mercury = require("./languages/mercury.js");
const mipsasm = require("./languages/mipsasm.js");
const mizar = require("./languages/mizar.js");
const perl = require("./languages/perl.js");
const mojolicious = require("./languages/mojolicious.js");
const monkey = require("./languages/monkey.js");
const moonscript = require("./languages/moonscript.js");
const n1ql = require("./languages/n1ql.js");
const nestedtext = require("./languages/nestedtext.js");
const nginx = require("./languages/nginx.js");
const nim = require("./languages/nim.js");
const nix = require("./languages/nix.js");
const nodeRepl = require("./languages/node-repl.js");
const nsis = require("./languages/nsis.js");
const objectivec = require("./languages/objectivec.js");
const ocaml = require("./languages/ocaml.js");
const openscad = require("./languages/openscad.js");
const oxygene = require("./languages/oxygene.js");
const parser3 = require("./languages/parser3.js");
const pf = require("./languages/pf.js");
const pgsql = require("./languages/pgsql.js");
const php = require("./languages/php.js");
const phpTemplate = require("./languages/php-template.js");
const plaintext = require("./languages/plaintext.js");
const pony = require("./languages/pony.js");
const powershell = require("./languages/powershell.js");
const processing = require("./languages/processing.js");
const profile = require("./languages/profile.js");
const prolog = require("./languages/prolog.js");
const properties = require("./languages/properties.js");
const protobuf = require("./languages/protobuf.js");
const puppet = require("./languages/puppet.js");
const purebasic = require("./languages/purebasic.js");
const python = require("./languages/python.js");
const pythonRepl = require("./languages/python-repl.js");
const q = require("./languages/q.js");
const qml = require("./languages/qml.js");
const r = require("./languages/r.js");
const reasonml = require("./languages/reasonml.js");
const rib = require("./languages/rib.js");
const roboconf = require("./languages/roboconf.js");
const routeros = require("./languages/routeros.js");
const rsl = require("./languages/rsl.js");
const ruleslanguage = require("./languages/ruleslanguage.js");
const rust = require("./languages/rust.js");
const sas = require("./languages/sas.js");
const scala = require("./languages/scala.js");
const scheme = require("./languages/scheme.js");
const scilab = require("./languages/scilab.js");
const scss = require("./languages/scss.js");
const shell = require("./languages/shell.js");
const smali = require("./languages/smali.js");
const smalltalk = require("./languages/smalltalk.js");
const sml = require("./languages/sml.js");
const sqf = require("./languages/sqf.js");
const sql = require("./languages/sql.js");
const stan = require("./languages/stan.js");
const stata = require("./languages/stata.js");
const step21 = require("./languages/step21.js");
const stylus = require("./languages/stylus.js");
const subunit = require("./languages/subunit.js");
const swift = require("./languages/swift.js");
const taggerscript = require("./languages/taggerscript.js");
const yaml = require("./languages/yaml.js");
const tap = require("./languages/tap.js");
const tcl = require("./languages/tcl.js");
const thrift = require("./languages/thrift.js");
const tp = require("./languages/tp.js");
const twig = require("./languages/twig.js");
const typescript = require("./languages/typescript.js");
const vala = require("./languages/vala.js");
const vbnet = require("./languages/vbnet.js");
const vbscript = require("./languages/vbscript.js");
const vbscriptHtml = require("./languages/vbscript-html.js");
const verilog = require("./languages/verilog.js");
const vhdl = require("./languages/vhdl.js");
const vim = require("./languages/vim.js");
const wasm = require("./languages/wasm.js");
const wren = require("./languages/wren.js");
const x86asm = require("./languages/x86asm.js");
const xl = require("./languages/xl.js");
const xquery = require("./languages/xquery.js");
const zephir = require("./languages/zephir.js");
var hljs = core.core;
hljs.registerLanguage("1c", _1c.__require());
hljs.registerLanguage("abnf", abnf.__require());
hljs.registerLanguage("accesslog", accesslog.__require());
hljs.registerLanguage("actionscript", actionscript.__require());
hljs.registerLanguage("ada", ada.__require());
hljs.registerLanguage("angelscript", angelscript.__require());
hljs.registerLanguage("apache", apache.__require());
hljs.registerLanguage("applescript", applescript.__require());
hljs.registerLanguage("arcade", arcade.__require());
hljs.registerLanguage("arduino", arduino.__require());
hljs.registerLanguage("armasm", armasm.__require());
hljs.registerLanguage("xml", xml.__require());
hljs.registerLanguage("asciidoc", asciidoc.__require());
hljs.registerLanguage("aspectj", aspectj.__require());
hljs.registerLanguage("autohotkey", autohotkey.__require());
hljs.registerLanguage("autoit", autoit.__require());
hljs.registerLanguage("avrasm", avrasm.__require());
hljs.registerLanguage("awk", awk.__require());
hljs.registerLanguage("axapta", axapta.__require());
hljs.registerLanguage("bash", bash.__require());
hljs.registerLanguage("basic", basic.__require());
hljs.registerLanguage("bnf", bnf.__require());
hljs.registerLanguage("brainfuck", brainfuck.__require());
hljs.registerLanguage("c", c.__require());
hljs.registerLanguage("cal", cal.__require());
hljs.registerLanguage("capnproto", capnproto.__require());
hljs.registerLanguage("ceylon", ceylon.__require());
hljs.registerLanguage("clean", clean.__require());
hljs.registerLanguage("clojure", clojure.__require());
hljs.registerLanguage("clojure-repl", clojureRepl.__require());
hljs.registerLanguage("cmake", cmake.__require());
hljs.registerLanguage("coffeescript", coffeescript.__require());
hljs.registerLanguage("coq", coq.__require());
hljs.registerLanguage("cos", cos.__require());
hljs.registerLanguage("cpp", cpp.__require());
hljs.registerLanguage("crmsh", crmsh.__require());
hljs.registerLanguage("crystal", crystal.__require());
hljs.registerLanguage("csharp", csharp.__require());
hljs.registerLanguage("csp", csp.__require());
hljs.registerLanguage("css", css.__require());
hljs.registerLanguage("d", d.__require());
hljs.registerLanguage("markdown", markdown.__require());
hljs.registerLanguage("dart", dart.__require());
hljs.registerLanguage("delphi", delphi.__require());
hljs.registerLanguage("diff", diff.__require());
hljs.registerLanguage("django", django.__require());
hljs.registerLanguage("dns", dns.__require());
hljs.registerLanguage("dockerfile", dockerfile.__require());
hljs.registerLanguage("dos", dos.__require());
hljs.registerLanguage("dsconfig", dsconfig.__require());
hljs.registerLanguage("dts", dts.__require());
hljs.registerLanguage("dust", dust.__require());
hljs.registerLanguage("ebnf", ebnf.__require());
hljs.registerLanguage("elixir", elixir.__require());
hljs.registerLanguage("elm", elm.__require());
hljs.registerLanguage("ruby", ruby.__require());
hljs.registerLanguage("erb", erb.__require());
hljs.registerLanguage("erlang-repl", erlangRepl.__require());
hljs.registerLanguage("erlang", erlang.__require());
hljs.registerLanguage("excel", excel.__require());
hljs.registerLanguage("fix", fix.__require());
hljs.registerLanguage("flix", flix.__require());
hljs.registerLanguage("fortran", fortran.__require());
hljs.registerLanguage("fsharp", fsharp.__require());
hljs.registerLanguage("gams", gams.__require());
hljs.registerLanguage("gauss", gauss.__require());
hljs.registerLanguage("gcode", gcode.__require());
hljs.registerLanguage("gherkin", gherkin.__require());
hljs.registerLanguage("glsl", glsl.__require());
hljs.registerLanguage("gml", gml.__require());
hljs.registerLanguage("go", go.__require());
hljs.registerLanguage("golo", golo.__require());
hljs.registerLanguage("gradle", gradle.__require());
hljs.registerLanguage("graphql", graphql.__require());
hljs.registerLanguage("groovy", groovy.__require());
hljs.registerLanguage("haml", haml.__require());
hljs.registerLanguage("handlebars", handlebars.__require());
hljs.registerLanguage("haskell", haskell.__require());
hljs.registerLanguage("haxe", haxe.__require());
hljs.registerLanguage("hsp", hsp.__require());
hljs.registerLanguage("http", http.__require());
hljs.registerLanguage("hy", hy.__require());
hljs.registerLanguage("inform7", inform7.__require());
hljs.registerLanguage("ini", ini.__require());
hljs.registerLanguage("irpf90", irpf90.__require());
hljs.registerLanguage("isbl", isbl.__require());
hljs.registerLanguage("java", java.__require());
hljs.registerLanguage("javascript", javascript.__require());
hljs.registerLanguage("jboss-cli", jbossCli.__require());
hljs.registerLanguage("json", json.__require());
hljs.registerLanguage("julia", julia.__require());
hljs.registerLanguage("julia-repl", juliaRepl.__require());
hljs.registerLanguage("kotlin", kotlin.__require());
hljs.registerLanguage("lasso", lasso.__require());
hljs.registerLanguage("latex", latex.__require());
hljs.registerLanguage("ldif", ldif.__require());
hljs.registerLanguage("leaf", leaf.__require());
hljs.registerLanguage("less", less.__require());
hljs.registerLanguage("lisp", lisp.__require());
hljs.registerLanguage("livecodeserver", livecodeserver.__require());
hljs.registerLanguage("livescript", livescript.__require());
hljs.registerLanguage("llvm", llvm.__require());
hljs.registerLanguage("lsl", lsl.__require());
hljs.registerLanguage("lua", lua.__require());
hljs.registerLanguage("makefile", makefile.__require());
hljs.registerLanguage("mathematica", mathematica.__require());
hljs.registerLanguage("matlab", matlab.__require());
hljs.registerLanguage("maxima", maxima.__require());
hljs.registerLanguage("mel", mel.__require());
hljs.registerLanguage("mercury", mercury.__require());
hljs.registerLanguage("mipsasm", mipsasm.__require());
hljs.registerLanguage("mizar", mizar.__require());
hljs.registerLanguage("perl", perl.__require());
hljs.registerLanguage("mojolicious", mojolicious.__require());
hljs.registerLanguage("monkey", monkey.__require());
hljs.registerLanguage("moonscript", moonscript.__require());
hljs.registerLanguage("n1ql", n1ql.__require());
hljs.registerLanguage("nestedtext", nestedtext.__require());
hljs.registerLanguage("nginx", nginx.__require());
hljs.registerLanguage("nim", nim.__require());
hljs.registerLanguage("nix", nix.__require());
hljs.registerLanguage("node-repl", nodeRepl.__require());
hljs.registerLanguage("nsis", nsis.__require());
hljs.registerLanguage("objectivec", objectivec.__require());
hljs.registerLanguage("ocaml", ocaml.__require());
hljs.registerLanguage("openscad", openscad.__require());
hljs.registerLanguage("oxygene", oxygene.__require());
hljs.registerLanguage("parser3", parser3.__require());
hljs.registerLanguage("pf", pf.__require());
hljs.registerLanguage("pgsql", pgsql.__require());
hljs.registerLanguage("php", php.__require());
hljs.registerLanguage("php-template", phpTemplate.__require());
hljs.registerLanguage("plaintext", plaintext.__require());
hljs.registerLanguage("pony", pony.__require());
hljs.registerLanguage("powershell", powershell.__require());
hljs.registerLanguage("processing", processing.__require());
hljs.registerLanguage("profile", profile.__require());
hljs.registerLanguage("prolog", prolog.__require());
hljs.registerLanguage("properties", properties.__require());
hljs.registerLanguage("protobuf", protobuf.__require());
hljs.registerLanguage("puppet", puppet.__require());
hljs.registerLanguage("purebasic", purebasic.__require());
hljs.registerLanguage("python", python.__require());
hljs.registerLanguage("python-repl", pythonRepl.__require());
hljs.registerLanguage("q", q.__require());
hljs.registerLanguage("qml", qml.__require());
hljs.registerLanguage("r", r.__require());
hljs.registerLanguage("reasonml", reasonml.__require());
hljs.registerLanguage("rib", rib.__require());
hljs.registerLanguage("roboconf", roboconf.__require());
hljs.registerLanguage("routeros", routeros.__require());
hljs.registerLanguage("rsl", rsl.__require());
hljs.registerLanguage("ruleslanguage", ruleslanguage.__require());
hljs.registerLanguage("rust", rust.__require());
hljs.registerLanguage("sas", sas.__require());
hljs.registerLanguage("scala", scala.__require());
hljs.registerLanguage("scheme", scheme.__require());
hljs.registerLanguage("scilab", scilab.__require());
hljs.registerLanguage("scss", scss.__require());
hljs.registerLanguage("shell", shell.__require());
hljs.registerLanguage("smali", smali.__require());
hljs.registerLanguage("smalltalk", smalltalk.__require());
hljs.registerLanguage("sml", sml.__require());
hljs.registerLanguage("sqf", sqf.__require());
hljs.registerLanguage("sql", sql.__require());
hljs.registerLanguage("stan", stan.__require());
hljs.registerLanguage("stata", stata.__require());
hljs.registerLanguage("step21", step21.__require());
hljs.registerLanguage("stylus", stylus.__require());
hljs.registerLanguage("subunit", subunit.__require());
hljs.registerLanguage("swift", swift.__require());
hljs.registerLanguage("taggerscript", taggerscript.__require());
hljs.registerLanguage("yaml", yaml.__require());
hljs.registerLanguage("tap", tap.__require());
hljs.registerLanguage("tcl", tcl.__require());
hljs.registerLanguage("thrift", thrift.__require());
hljs.registerLanguage("tp", tp.__require());
hljs.registerLanguage("twig", twig.__require());
hljs.registerLanguage("typescript", typescript.__require());
hljs.registerLanguage("vala", vala.__require());
hljs.registerLanguage("vbnet", vbnet.__require());
hljs.registerLanguage("vbscript", vbscript.__require());
hljs.registerLanguage("vbscript-html", vbscriptHtml.__require());
hljs.registerLanguage("verilog", verilog.__require());
hljs.registerLanguage("vhdl", vhdl.__require());
hljs.registerLanguage("vim", vim.__require());
hljs.registerLanguage("wasm", wasm.__require());
hljs.registerLanguage("wren", wren.__require());
hljs.registerLanguage("x86asm", x86asm.__require());
hljs.registerLanguage("xl", xl.__require());
hljs.registerLanguage("xquery", xquery.__require());
hljs.registerLanguage("zephir", zephir.__require());
hljs.HighlightJS = hljs;
hljs.default = hljs;
var lib = hljs;
const HighlightJS = /* @__PURE__ */ _commonjsHelpers.getDefaultExportFromCjs(lib);
exports.default = HighlightJS;
