"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const blockquote = require("./blockquote.js");
const _break = require("./break.js");
const code = require("./code.js");
const _delete = require("./delete.js");
const emphasis = require("./emphasis.js");
const footnoteReference = require("./footnote-reference.js");
const heading = require("./heading.js");
const html = require("./html.js");
const imageReference = require("./image-reference.js");
const image = require("./image.js");
const inlineCode = require("./inline-code.js");
const linkReference = require("./link-reference.js");
const link = require("./link.js");
const listItem = require("./list-item.js");
const list = require("./list.js");
const paragraph = require("./paragraph.js");
const root = require("./root.js");
const strong = require("./strong.js");
const table = require("./table.js");
const tableRow = require("./table-row.js");
const tableCell = require("./table-cell.js");
const text = require("./text.js");
const thematicBreak = require("./thematic-break.js");
const handlers = {
  blockquote: blockquote.blockquote,
  break: _break.hardBreak,
  code: code.code,
  delete: _delete.strikethrough,
  emphasis: emphasis.emphasis,
  footnoteReference: footnoteReference.footnoteReference,
  heading: heading.heading,
  html: html.html,
  imageReference: imageReference.imageReference,
  image: image.image,
  inlineCode: inlineCode.inlineCode,
  linkReference: linkReference.linkReference,
  link: link.link,
  listItem: listItem.listItem,
  list: list.list,
  paragraph: paragraph.paragraph,
  // @ts-expect-error: root is different, but hard to type.
  root: root.root,
  strong: strong.strong,
  table: table.table,
  tableCell: tableCell.tableCell,
  tableRow: tableRow.tableRow,
  text: text.text,
  thematicBreak: thematicBreak.thematicBreak,
  toml: ignore,
  yaml: ignore,
  definition: ignore,
  footnoteDefinition: ignore
};
function ignore() {
  return void 0;
}
exports.handlers = handlers;
