"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const index$4 = require("../../../../micromark-factory-destination@2.0.0/node_modules/micromark-factory-destination/index.js");
const index = require("../../../../micromark-factory-label@2.0.0/node_modules/micromark-factory-label/index.js");
const index$5 = require("../../../../micromark-factory-space@2.0.0/node_modules/micromark-factory-space/index.js");
const index$6 = require("../../../../micromark-factory-title@2.0.0/node_modules/micromark-factory-title/index.js");
const index$3 = require("../../../../micromark-factory-whitespace@2.0.0/node_modules/micromark-factory-whitespace/index.js");
const index$2 = require("../../../../micromark-util-character@2.1.1/node_modules/micromark-util-character/index.js");
const index$1 = require("../../../../micromark-util-normalize-identifier@2.0.0/node_modules/micromark-util-normalize-identifier/index.js");
const definition = {
  name: "definition",
  tokenize: tokenizeDefinition
};
const titleBefore = {
  tokenize: tokenizeTitleBefore,
  partial: true
};
function tokenizeDefinition(effects, ok, nok) {
  const self = this;
  let identifier;
  return start;
  function start(code) {
    effects.enter("definition");
    return before(code);
  }
  function before(code) {
    return index.factoryLabel.call(
      self,
      effects,
      labelAfter,
      // Note: we don’t need to reset the way `markdown-rs` does.
      nok,
      "definitionLabel",
      "definitionLabelMarker",
      "definitionLabelString"
    )(code);
  }
  function labelAfter(code) {
    identifier = index$1.normalizeIdentifier(self.sliceSerialize(self.events[self.events.length - 1][1]).slice(1, -1));
    if (code === 58) {
      effects.enter("definitionMarker");
      effects.consume(code);
      effects.exit("definitionMarker");
      return markerAfter;
    }
    return nok(code);
  }
  function markerAfter(code) {
    return index$2.markdownLineEndingOrSpace(code) ? index$3.factoryWhitespace(effects, destinationBefore)(code) : destinationBefore(code);
  }
  function destinationBefore(code) {
    return index$4.factoryDestination(
      effects,
      destinationAfter,
      // Note: we don’t need to reset the way `markdown-rs` does.
      nok,
      "definitionDestination",
      "definitionDestinationLiteral",
      "definitionDestinationLiteralMarker",
      "definitionDestinationRaw",
      "definitionDestinationString"
    )(code);
  }
  function destinationAfter(code) {
    return effects.attempt(titleBefore, after, after)(code);
  }
  function after(code) {
    return index$2.markdownSpace(code) ? index$5.factorySpace(effects, afterWhitespace, "whitespace")(code) : afterWhitespace(code);
  }
  function afterWhitespace(code) {
    if (code === null || index$2.markdownLineEnding(code)) {
      effects.exit("definition");
      self.parser.defined.push(identifier);
      return ok(code);
    }
    return nok(code);
  }
}
function tokenizeTitleBefore(effects, ok, nok) {
  return titleBefore2;
  function titleBefore2(code) {
    return index$2.markdownLineEndingOrSpace(code) ? index$3.factoryWhitespace(effects, beforeMarker)(code) : nok(code);
  }
  function beforeMarker(code) {
    return index$6.factoryTitle(effects, titleAfter, nok, "definitionTitle", "definitionTitleMarker", "definitionTitleString")(code);
  }
  function titleAfter(code) {
    return index$2.markdownSpace(code) ? index$5.factorySpace(effects, titleAfterOptionalWhitespace, "whitespace")(code) : titleAfterOptionalWhitespace(code);
  }
  function titleAfterOptionalWhitespace(code) {
    return code === null || index$2.markdownLineEnding(code) ? ok(code) : nok(code);
  }
}
exports.definition = definition;
