"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const text$1 = require("./initialize/text.js");
const list = require("../../../../micromark-core-commonmark@2.0.1/node_modules/micromark-core-commonmark/lib/list.js");
const blockQuote = require("../../../../micromark-core-commonmark@2.0.1/node_modules/micromark-core-commonmark/lib/block-quote.js");
const definition = require("../../../../micromark-core-commonmark@2.0.1/node_modules/micromark-core-commonmark/lib/definition.js");
const codeIndented = require("../../../../micromark-core-commonmark@2.0.1/node_modules/micromark-core-commonmark/lib/code-indented.js");
const headingAtx = require("../../../../micromark-core-commonmark@2.0.1/node_modules/micromark-core-commonmark/lib/heading-atx.js");
const thematicBreak = require("../../../../micromark-core-commonmark@2.0.1/node_modules/micromark-core-commonmark/lib/thematic-break.js");
const setextUnderline = require("../../../../micromark-core-commonmark@2.0.1/node_modules/micromark-core-commonmark/lib/setext-underline.js");
const htmlFlow = require("../../../../micromark-core-commonmark@2.0.1/node_modules/micromark-core-commonmark/lib/html-flow.js");
const codeFenced = require("../../../../micromark-core-commonmark@2.0.1/node_modules/micromark-core-commonmark/lib/code-fenced.js");
const characterReference = require("../../../../micromark-core-commonmark@2.0.1/node_modules/micromark-core-commonmark/lib/character-reference.js");
const characterEscape = require("../../../../micromark-core-commonmark@2.0.1/node_modules/micromark-core-commonmark/lib/character-escape.js");
const lineEnding = require("../../../../micromark-core-commonmark@2.0.1/node_modules/micromark-core-commonmark/lib/line-ending.js");
const labelStartImage = require("../../../../micromark-core-commonmark@2.0.1/node_modules/micromark-core-commonmark/lib/label-start-image.js");
const attention = require("../../../../micromark-core-commonmark@2.0.1/node_modules/micromark-core-commonmark/lib/attention.js");
const autolink = require("../../../../micromark-core-commonmark@2.0.1/node_modules/micromark-core-commonmark/lib/autolink.js");
const htmlText = require("../../../../micromark-core-commonmark@2.0.1/node_modules/micromark-core-commonmark/lib/html-text.js");
const labelStartLink = require("../../../../micromark-core-commonmark@2.0.1/node_modules/micromark-core-commonmark/lib/label-start-link.js");
const hardBreakEscape = require("../../../../micromark-core-commonmark@2.0.1/node_modules/micromark-core-commonmark/lib/hard-break-escape.js");
const labelEnd = require("../../../../micromark-core-commonmark@2.0.1/node_modules/micromark-core-commonmark/lib/label-end.js");
const codeText = require("../../../../micromark-core-commonmark@2.0.1/node_modules/micromark-core-commonmark/lib/code-text.js");
const document = {
  [42]: list.list,
  [43]: list.list,
  [45]: list.list,
  [48]: list.list,
  [49]: list.list,
  [50]: list.list,
  [51]: list.list,
  [52]: list.list,
  [53]: list.list,
  [54]: list.list,
  [55]: list.list,
  [56]: list.list,
  [57]: list.list,
  [62]: blockQuote.blockQuote
};
const contentInitial = {
  [91]: definition.definition
};
const flowInitial = {
  [-2]: codeIndented.codeIndented,
  [-1]: codeIndented.codeIndented,
  [32]: codeIndented.codeIndented
};
const flow = {
  [35]: headingAtx.headingAtx,
  [42]: thematicBreak.thematicBreak,
  [45]: [setextUnderline.setextUnderline, thematicBreak.thematicBreak],
  [60]: htmlFlow.htmlFlow,
  [61]: setextUnderline.setextUnderline,
  [95]: thematicBreak.thematicBreak,
  [96]: codeFenced.codeFenced,
  [126]: codeFenced.codeFenced
};
const string = {
  [38]: characterReference.characterReference,
  [92]: characterEscape.characterEscape
};
const text = {
  [-5]: lineEnding.lineEnding,
  [-4]: lineEnding.lineEnding,
  [-3]: lineEnding.lineEnding,
  [33]: labelStartImage.labelStartImage,
  [38]: characterReference.characterReference,
  [42]: attention.attention,
  [60]: [autolink.autolink, htmlText.htmlText],
  [91]: labelStartLink.labelStartLink,
  [92]: [hardBreakEscape.hardBreakEscape, characterEscape.characterEscape],
  [93]: labelEnd.labelEnd,
  [95]: attention.attention,
  [96]: codeText.codeText
};
const insideSpan = {
  null: [attention.attention, text$1.resolver]
};
const attentionMarkers = {
  null: [42, 95]
};
const disable = {
  null: []
};
exports.attentionMarkers = attentionMarkers;
exports.contentInitial = contentInitial;
exports.disable = disable;
exports.document = document;
exports.flow = flow;
exports.flowInitial = flowInitial;
exports.insideSpan = insideSpan;
exports.string = string;
exports.text = text;
