"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const normalize = require("../normalize.js");
const schema = require("./schema.js");
const definedInfo = require("./defined-info.js");
const own = {}.hasOwnProperty;
function create(definition) {
  const property = {};
  const normal = {};
  let prop;
  for (prop in definition.properties) {
    if (own.call(definition.properties, prop)) {
      const value = definition.properties[prop];
      const info = new definedInfo.DefinedInfo(
        prop,
        definition.transform(definition.attributes || {}, prop),
        value,
        definition.space
      );
      if (definition.mustUseProperty && definition.mustUseProperty.includes(prop)) {
        info.mustUseProperty = true;
      }
      property[prop] = info;
      normal[normalize.normalize(prop)] = prop;
      normal[normalize.normalize(info.attribute)] = prop;
    }
  }
  return new schema.Schema(property, normal, definition.space);
}
exports.create = create;
