"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const info = require("./info.js");
const types = require("./types.js");
const checks = Object.keys(types);
class DefinedInfo extends info.Info {
  /**
   * @constructor
   * @param {string} property
   * @param {string} attribute
   * @param {number|null} [mask]
   * @param {string} [space]
   */
  constructor(property, attribute, mask, space) {
    let index = -1;
    super(property, attribute);
    mark(this, "space", space);
    if (typeof mask === "number") {
      while (++index < checks.length) {
        const check = checks[index];
        mark(this, checks[index], (mask & types[check]) === types[check]);
      }
    }
  }
}
DefinedInfo.prototype.defined = true;
function mark(values, key, value) {
  if (value) {
    values[key] = value;
  }
}
exports.DefinedInfo = DefinedInfo;
