"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const toHexadecimal = require("./to-hexadecimal.js");
const toDecimal = require("./to-decimal.js");
const toNamed = require("./to-named.js");
function formatSmart(code, next, options) {
  let numeric = toHexadecimal.toHexadecimal(code, next, options.omitOptionalSemicolons);
  let named;
  if (options.useNamedReferences || options.useShortestReferences) {
    named = toNamed.toNamed(
      code,
      next,
      options.omitOptionalSemicolons,
      options.attribute
    );
  }
  if ((options.useShortestReferences || !named) && options.useShortestReferences) {
    const decimal = toDecimal.toDecimal(code, next, options.omitOptionalSemicolons);
    if (decimal.length < numeric.length) {
      numeric = decimal;
    }
  }
  return named && (!options.useShortestReferences || named.length < numeric.length) ? named : numeric;
}
exports.formatSmart = formatSmart;
